"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _styleContainer = require("@cloudflare/style-container");

var _elements = require("@cloudflare/elements");

var _Table = require("./Table");

var _componentIcon = require("@cloudflare/component-icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// A11Y-94: Button to trigger sorting for keyboard users.
var SortButton = (0, _styleContainer.createStyledComponent)(function () {
  return {
    background: 'none',
    color: 'inherit',
    alignItems: 'center',
    display: 'flex',
    border: 'none',
    padding: 0,
    font: 'inherit',
    cursor: 'pointer',
    outline: 'inherit',
    width: '100%',
    '&:focus': {
      outline: 'solid',
      outlineOffset: 3,
      outlineStyle: 'auto',
      outlineColor: 'gray.8'
    }
  };
}, 'button');
var HeaderCellWrapper = (0, _styleContainer.createStyledComponent)(function (_ref) {
  var theme = _ref.theme,
      isLoading = _ref.isLoading,
      hasError = _ref.hasError,
      isEmpty = _ref.isEmpty,
      column = _ref.column;
  return _objectSpread(_objectSpread({
    display: 'flex',
    alignItems: 'center',
    fontSize: 2,
    fontWeight: 600,
    color: 'gray.1',
    pl: 2,
    pr: 2,
    pb: 1,
    pt: 1,
    backgroundColor: theme.colors.background,
    borderBottom: "1px solid ".concat(theme.colors.gray[7]),
    transition: 'opacity 0.2s, background-color 0.2s'
  }, column.canSort ? {
    cursor: 'pointer'
  } : {}), {}, {
    '&:hover': {
      backgroundColor: column.canSort && !isLoading && !hasError && !isEmpty && theme.colors.gray[9]
    }
  });
}, 'th');

var HeaderCell = function HeaderCell(_ref2) {
  var column = _ref2.column,
      isLoading = _ref2.isLoading,
      isEmpty = _ref2.isEmpty,
      hasError = _ref2.hasError,
      selectAllKey = _ref2.selectAllKey;
  return /*#__PURE__*/_react.default.createElement(HeaderCellWrapper, _extends({}, column.getHeaderProps({
    style: _objectSpread({}, (column.id === _Table.SELECTABLE_ID || column.id === _Table.EXPANDABLE_ID) && {
      flex: '0 0 auto'
    })
  }), {
    "aria-sort": column.isSorted ? column.isSortedDesc ? 'descending' : 'ascending' : 'none',
    isLoading: isLoading,
    hasError: hasError,
    isEmpty: isEmpty,
    column: column
  }), column.canSort ? /*#__PURE__*/_react.default.createElement(SortButton, {
    onClick: function onClick() {
      return column.toggleSortBy();
    }
  }, column.render('Header', {
    selectAllKey: selectAllKey
  }), column.canSort && !isLoading && !hasError && !isEmpty && /*#__PURE__*/_react.default.createElement(_elements.Div, {
    display: "flex",
    ml: 2,
    style: {
      transform: column.isSortedDesc ? 'rotate(-180deg)' : ''
    }
  }, column.isSorted ? /*#__PURE__*/_react.default.createElement(_componentIcon.Icon, {
    type: "caret-up",
    color: "gray.0",
    ariaLabel: ""
  }) : /*#__PURE__*/_react.default.createElement(_componentIcon.Icon, {
    type: "reorder",
    color: "gray.0",
    ariaLabel: "",
    size: 12
  }))) : column.render('Header', {
    selectAllKey: selectAllKey
  }));
};

var _default = HeaderCell;
exports.default = _default;